// Plugin Developed by Astoria
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.AreaManagement;
using Styx.Pathing;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Threading;
using System.Diagnostics;

namespace DynamicTPS
{
    public class DynamicTPS : HBPlugin
    {
        public override string Name { get { return "DynamicTPS"; } }
        public override string Author { get { return "Astoria"; } }
        public override Version Version { get { return _version; } }
        private readonly Version _version = new Version(1, 0, 0, 0);
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        public static DateTime _checkTimer;

        public override void OnEnable()
        {
            base.OnEnable();
            Logging.Write(Colors.OrangeRed, "DynamicTPS by Astoria Enable");
            Logging.Write(Colors.OrangeRed,"{0} ms of Latency in WOW", Convert.ToString(StyxWoW.WoWClient.Latency));
            Logging.Write(Colors.OrangeRed, "{0} Fps in WOW", Convert.ToString(StyxWoW.WoWClient.Fps));
            Logging.Write(Colors.OrangeRed, "{0} ticks in HB", Convert.ToString(TreeRoot.TicksPerSecond));
            Logging.Write(Colors.OrangeRed, "ClickToMove Disabled");
            Lua.DoString("SetCVar('autoInteract', '0')");

            _checkTimer = DateTime.Now + new TimeSpan(0, 0, 0, 1, 0);

            Process[] procs = Process.GetProcessesByName("Wow");

            foreach (Process p in procs)
            {
                //Logging.Write(String.Format("{0}\t{1}", p.Id, p.ProcessName));
                Process wowProc = Process.GetProcessById(p.Id);
                wowProc.PriorityClass = ProcessPriorityClass.High;
                Logging.Write(Colors.OrangeRed, "Adjusting Wow Process set to high.");

                Process hbProc = Process.GetCurrentProcess();
                hbProc.PriorityClass = ProcessPriorityClass.High;
                Logging.Write(Colors.OrangeRed, "Adjusting HB Process set to high.");
            }
        }

        public override void OnDisable()
        {
            TreeRoot.TicksPerSecond = 15;
            Logging.Write(Colors.OrangeRed, "DynamicTPS Disable - Set Tick to 15.");
            base.OnDisable();
        }

        public override void Pulse()
        {
            Lua.DoString("SetCVar('autoInteract', '0')");
            if (DateTime.Now >= _checkTimer)
            {
                var Fps = StyxWoW.WoWClient.Fps;
                var Ticks = TreeRoot.TicksPerSecond;

                if (!Me.Combat)
                {
                    var actualTick = 15;
                    TreeRoot.TicksPerSecond = 15;

                    if (Ticks != actualTick)
                    {
                        Logging.Write(Colors.OrangeRed, "DynamicTPS adjusted tps for non combat mode.");
                    }
                }
                if (Fps < 10 && Me.Combat)
                {
                    var actualTick = 5;
                    TreeRoot.TicksPerSecond = 5;
                    StyxWoW.Overlay.Dispatcher.InvokeShutdown();

                    if (Ticks != actualTick)
                    {
                        Logging.Write(Colors.OrangeRed, "DynamicTPS adjusted tps to 5 ticks.");
                    }
                }
                if (Fps > 10 && Fps < 20 && Me.Combat)
                {
                    var actualTick = 15;
                    TreeRoot.TicksPerSecond = 15;         

                    if (Ticks != actualTick)
                    {
                        Logging.Write(Colors.OrangeRed, "DynamicTPS adjusted tps to 15 ticks.");
                    }
                }
                if (Fps > 20 && Fps < 80 && Me.Combat)
                {
                    var actualTick = 30;
                    TreeRoot.TicksPerSecond = 30;

                    if (Ticks != actualTick)
                    {
                        Logging.Write(Colors.OrangeRed, "DynamicTPS adjusted tps to 30 ticks.");
                    }
                }
                if (Fps > 90 && Me.Combat)
                {
                    var actualTick = 60;
                    TreeRoot.TicksPerSecond = 60;

                    if (Ticks != actualTick)
                    {
                        Logging.Write(Colors.OrangeRed, "DynamicTPS adjusted tps to 60 ticks.");
                    }
                }

                _checkTimer = DateTime.Now + new TimeSpan(0, 0, 0, 1, 0);
            }
        }
    }
}